/* 
 * keypad
 *
 * A suite of communication APIs for web and enterprise applications
 *
 * OpenAPI spec version: v1
 * Contact: fmalka@modulo.co.il
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using SeriousSIP.Client;
using SeriousSIP.Model;

namespace SeriousSIP.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public interface IBridgesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgeGet (string id = null);

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgeGetWithHttpInfo (string id = null);
        /// <summary>
        /// Playback an audio clip to the bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgePlayPut (BridgePlayParams body = null, string id = null);

        /// <summary>
        /// Playback an audio clip to the bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgePlayPutWithHttpInfo (BridgePlayParams body = null, string id = null);
        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgePlayStopPut (string id = null);

        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgePlayStopPutWithHttpInfo (string id = null);
        /// <summary>
        /// Create a new bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgePost (BridgeCreateParams body = null);

        /// <summary>
        /// Create a new bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgePostWithHttpInfo (BridgeCreateParams body = null);
        /// <summary>
        /// Record the 2 bridged legs to an audio clip.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgeRecordPut (BridgeRecordParams body = null, string id = null);

        /// <summary>
        /// Record the 2 bridged legs to an audio clip.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgeRecordPutWithHttpInfo (BridgeRecordParams body = null, string id = null);
        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgeRecordStopPut (string id = null);

        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgeRecordStopPutWithHttpInfo (string id = null);
        /// <summary>
        /// Terminate a previously established bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesBridgeTerminateDelete (string id = null, bool? dropCalls = null);

        /// <summary>
        /// Terminate a previously established bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesBridgeTerminateDeleteWithHttpInfo (string id = null, bool? dropCalls = null);
        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesSubscribePost (BridgesSubscribeParams body = null);

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesSubscribePostWithHttpInfo (BridgesSubscribeParams body = null);
        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        ResponseParams ApiV1BridgesUnsubscribePut (BridgesUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> ApiV1BridgesUnsubscribePutWithHttpInfo (BridgesUnsubscribeParams body = null);
        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        ResponseParams Bridges ();

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        ApiResponse<ResponseParams> BridgesWithHttpInfo ();
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeGetAsync (string id = null);

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeGetAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Playback an audio clip to the bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePlayPutAsync (BridgePlayParams body = null, string id = null);

        /// <summary>
        /// Playback an audio clip to the bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePlayPutAsyncWithHttpInfo (BridgePlayParams body = null, string id = null);
        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePlayStopPutAsync (string id = null);

        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePlayStopPutAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Create a new bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePostAsync (BridgeCreateParams body = null);

        /// <summary>
        /// Create a new bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePostAsyncWithHttpInfo (BridgeCreateParams body = null);
        /// <summary>
        /// Record the 2 bridged legs to an audio clip.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeRecordPutAsync (BridgeRecordParams body = null, string id = null);

        /// <summary>
        /// Record the 2 bridged legs to an audio clip.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeRecordPutAsyncWithHttpInfo (BridgeRecordParams body = null, string id = null);
        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeRecordStopPutAsync (string id = null);

        /// <summary>
        /// Stop a previous media action for a bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeRecordStopPutAsyncWithHttpInfo (string id = null);
        /// <summary>
        /// Terminate a previously established bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeTerminateDeleteAsync (string id = null, bool? dropCalls = null);

        /// <summary>
        /// Terminate a previously established bridge.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeTerminateDeleteAsyncWithHttpInfo (string id = null, bool? dropCalls = null);
        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesSubscribePostAsync (BridgesSubscribeParams body = null);

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesSubscribePostAsyncWithHttpInfo (BridgesSubscribeParams body = null);
        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesUnsubscribePutAsync (BridgesUnsubscribeParams body = null);

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesUnsubscribePutAsyncWithHttpInfo (BridgesUnsubscribeParams body = null);
        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        System.Threading.Tasks.Task<ResponseParams> BridgesAsync ();

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        System.Threading.Tasks.Task<ApiResponse<ResponseParams>> BridgesAsyncWithHttpInfo ();
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
        public partial class BridgesApi : IBridgesApi
    {
        private SeriousSIP.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="BridgesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public BridgesApi(String basePath)
        {
            this.Configuration = new SeriousSIP.Client.Configuration { BasePath = basePath };

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BridgesApi"/> class
        /// </summary>
        /// <returns></returns>
        public BridgesApi()
        {
            this.Configuration = SeriousSIP.Client.Configuration.Default;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="BridgesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public BridgesApi(SeriousSIP.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = SeriousSIP.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = SeriousSIP.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public SeriousSIP.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public SeriousSIP.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgeGet (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgeGetWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgeGetWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeGetAsync (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgeGetAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve information of one specific bridge using its unique ID. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeGetAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeGet", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Playback an audio clip to the bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgePlayPut (BridgePlayParams body = null, string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgePlayPutWithHttpInfo(body, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Playback an audio clip to the bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgePlayPutWithHttpInfo (BridgePlayParams body = null, string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/play";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePlayPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Playback an audio clip to the bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePlayPutAsync (BridgePlayParams body = null, string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgePlayPutAsyncWithHttpInfo(body, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Playback an audio clip to the bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgePlayParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to playback on. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePlayPutAsyncWithHttpInfo (BridgePlayParams body = null, string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/play";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePlayPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgePlayStopPut (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgePlayStopPutWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgePlayStopPutWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/play/stop";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePlayStopPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePlayStopPutAsync (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgePlayStopPutAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePlayStopPutAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/play/stop";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePlayStopPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Create a new bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgePost (BridgeCreateParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgePostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgePostWithHttpInfo (BridgeCreateParams body = null)
        {

            var localVarPath = "/api/v1/bridges/bridge";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Create a new bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgePostAsync (BridgeCreateParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgePostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeCreateParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgePostAsyncWithHttpInfo (BridgeCreateParams body = null)
        {

            var localVarPath = "/api/v1/bridges/bridge";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Record the 2 bridged legs to an audio clip. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgeRecordPut (BridgeRecordParams body = null, string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgeRecordPutWithHttpInfo(body, id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Record the 2 bridged legs to an audio clip. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgeRecordPutWithHttpInfo (BridgeRecordParams body = null, string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/record";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeRecordPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Record the 2 bridged legs to an audio clip. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeRecordPutAsync (BridgeRecordParams body = null, string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgeRecordPutAsyncWithHttpInfo(body, id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Record the 2 bridged legs to an audio clip. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgeRecordParams parameter block for details. (optional)</param>
        /// <param name="id">The unique ID of the bridge to record on. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeRecordPutAsyncWithHttpInfo (BridgeRecordParams body = null, string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/record";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeRecordPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgeRecordStopPut (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgeRecordStopPutWithHttpInfo(id);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgeRecordStopPutWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/record/stop";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeRecordStopPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeRecordStopPutAsync (string id = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgeRecordStopPutAsyncWithHttpInfo(id);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Stop a previous media action for a bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the bridge to stop the media action. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeRecordStopPutAsyncWithHttpInfo (string id = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/record/stop";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeRecordStopPut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Terminate a previously established bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesBridgeTerminateDelete (string id = null, bool? dropCalls = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesBridgeTerminateDeleteWithHttpInfo(id, dropCalls);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Terminate a previously established bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesBridgeTerminateDeleteWithHttpInfo (string id = null, bool? dropCalls = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/terminate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (dropCalls != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dropCalls", dropCalls)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeTerminateDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Terminate a previously established bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesBridgeTerminateDeleteAsync (string id = null, bool? dropCalls = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesBridgeTerminateDeleteAsyncWithHttpInfo(id, dropCalls);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Terminate a previously established bridge. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="id">The unique ID of the call to disconnect. (optional)</param>
        /// <param name="dropCalls">If true, drops the calls associated with the bridge. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesBridgeTerminateDeleteAsyncWithHttpInfo (string id = null, bool? dropCalls = null)
        {

            var localVarPath = "/api/v1/bridges/bridge/terminate";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (id != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "id", id)); // query parameter
            if (dropCalls != null) localVarQueryParams.AddRange(this.Configuration.ApiClient.ParameterToKeyValuePairs("", "dropCalls", dropCalls)); // query parameter

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesBridgeTerminateDelete", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesSubscribePost (BridgesSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesSubscribePostWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesSubscribePostWithHttpInfo (BridgesSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/bridges/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesSubscribePostAsync (BridgesSubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesSubscribePostAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Subscribe to call server events to recieve webhook notifications on bridge play/record events. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesSubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesSubscribePostAsyncWithHttpInfo (BridgesSubscribeParams body = null)
        {

            var localVarPath = "/api/v1/bridges/subscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesSubscribePost", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ResponseParams</returns>
        public ResponseParams ApiV1BridgesUnsubscribePut (BridgesUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = ApiV1BridgesUnsubscribePutWithHttpInfo(body);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > ApiV1BridgesUnsubscribePutWithHttpInfo (BridgesUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/bridges/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> ApiV1BridgesUnsubscribePutAsync (BridgesUnsubscribeParams body = null)
        {
             ApiResponse<ResponseParams> localVarResponse = await ApiV1BridgesUnsubscribePutAsyncWithHttpInfo(body);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Unsubscribe, cancel all the webhook bridges for one or more identities. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="body">See the BridgesUnsubscribeParams parameter block for details. (optional)</param>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> ApiV1BridgesUnsubscribePutAsyncWithHttpInfo (BridgesUnsubscribeParams body = null)
        {

            var localVarPath = "/api/v1/bridges/unsubscribe";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (body != null && body.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(body); // http body (model) parameter
            }
            else
            {
                localVarPostBody = body; // byte array
            }

            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ApiV1BridgesUnsubscribePut", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ResponseParams</returns>
        public ResponseParams Bridges ()
        {
             ApiResponse<ResponseParams> localVarResponse = BridgesWithHttpInfo();
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>ApiResponse of ResponseParams</returns>
        public ApiResponse< ResponseParams > BridgesWithHttpInfo ()
        {

            var localVarPath = "/api/v1/bridges";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Bridges", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ResponseParams</returns>
        public async System.Threading.Tasks.Task<ResponseParams> BridgesAsync ()
        {
             ApiResponse<ResponseParams> localVarResponse = await BridgesAsyncWithHttpInfo();
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve all the bridges currently being handled by the call server. 
        /// </summary>
        /// <exception cref="SeriousSIP.Client.ApiException">Thrown when fails to make API call</exception>
        /// <returns>Task of ApiResponse (ResponseParams)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ResponseParams>> BridgesAsyncWithHttpInfo ()
        {

            var localVarPath = "/api/v1/bridges";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Bridges", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ResponseParams>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => string.Join(",", x.Value)),
                (ResponseParams) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ResponseParams)));
        }

    }
}
